Option Strict On
Option Explicit On 

Imports System.Drawing.Printing

Public Class stage
    Inherits System.Windows.Forms.Form
    Private Declare Auto Function BitBlt Lib "gdi32.dll" (ByVal hdcDest As IntPtr, ByVal nXDest As Integer, ByVal nYDest As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hdcSrc As IntPtr, ByVal nXSrc As Integer, ByVal nYSrc As Integer, ByVal dwRop As System.Int32) As Boolean
    Private Const SRCCOPY As Integer = &HCC0020
    Private m_PrintBitmap As Bitmap
    Private WithEvents m_PrintDocument As PrintDocument
    ' variabili base del form
    Private Nome As String ' Nome del file
    Private InizioDisegno As Boolean = False ' inizia a disegnare 
    Private F_S As Single 'fattore schermo
    Private D_F As Single 'dimensione font
    Private T_F As String 'tipo font
    Private LAR As Integer = 1 ' larghezza penna
    Private ALT As Integer = 1 ' altezza penna
    Private COL As Color = Color.Black ' colore penna
    Private COLSTAGE As Color = Color.White ' colore stage
    Private LARform As Integer ' attr. form
    Private ALTform As Integer ' attr. form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Pic1 As System.Windows.Forms.PictureBox
    Friend WithEvents PrintDocument1 As System.Drawing.Printing.PrintDocument
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Pic1 = New System.Windows.Forms.PictureBox
        Me.PrintDocument1 = New System.Drawing.Printing.PrintDocument
        Me.SuspendLayout()
        '
        'Pic1
        '
        Me.Pic1.BackColor = System.Drawing.Color.White
        Me.Pic1.Location = New System.Drawing.Point(8, 8)
        Me.Pic1.Name = "Pic1"
        Me.Pic1.Size = New System.Drawing.Size(100, 100)
        Me.Pic1.TabIndex = 0
        Me.Pic1.TabStop = False
        '
        'stage
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.AutoScroll = True
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Controls.Add(Me.Pic1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.Name = "stage"
        Me.Text = "stage"
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "PROPRIETA"

    Property FattoreSchermo() As Single
        ' fattore per la risoluzione dello schermo
        Get
            FattoreSchermo = F_S
        End Get
        Set(ByVal Value As Single)
            If Value < 1 Then
                MsgBox("Attenzione non  stato possibile cambiare il valore della risoluzione dello schermo.", MsgBoxStyle.Information, "ERR [6]")
                Exit Property
            End If
            F_S = Value
        End Set
    End Property

    Property DimensioneFont() As Single
        ' dimensione del font
        Get
            DimensioneFont = D_F
        End Get
        Set(ByVal Value As Single)
            If Value < 1 Then
                MsgBox("Attenzione non  stato possibile cambiare la dimensione del Font.", MsgBoxStyle.Information, "ERR [7]")
                Exit Property
            End If
            D_F = Value
        End Set
    End Property


    Property TipoFont() As String
        ' nome esteso del font
        Get
            TipoFont = T_F
        End Get
        Set(ByVal Value As String)
            If Value = "" Then
                MsgBox("Attenzione non  stato possibile cambiare il Tipo di Font.", MsgBoxStyle.Information, "ERR [8]")
                Exit Property
            End If
            T_F = Value
        End Set
    End Property

    Property NomeFile() As String
        ' nome del file
        Get
            NomeFile = Nome
        End Get
        Set(ByVal Value As String)
            Nome = Value
        End Set
    End Property

    Property LarghezzaForm() As Integer
        ' larghezza del form
        Get
            LarghezzaForm = LARform
        End Get
        Set(ByVal Value As Integer)
            LARform = Value
        End Set
    End Property

    Property AltezzaForm() As Integer
        ' altezza del form
        Get
            AltezzaForm = ALTform
        End Get
        Set(ByVal Value As Integer)
            ALTform = Value
        End Set
    End Property

    Property LarghezzaLinea() As Integer
        ' larghezza della penna
        Get
            LarghezzaLinea = LAR
        End Get
        Set(ByVal Value As Integer)
            LAR = Value
        End Set
    End Property

    Property AltezzaLinea() As Integer
        ' altezza della penna
        Get
            AltezzaLinea = ALT
        End Get
        Set(ByVal Value As Integer)
            ALT = Value
        End Set
    End Property

    Property ColoreStage() As Color
        ' colore dello stage del form
        Get
            ColoreStage = COLSTAGE
        End Get
        Set(ByVal Value As Color)
            COLSTAGE = Value
        End Set
    End Property

    Property ColorePenna() As Color
        ' colore della penna
        Get
            ColorePenna = COL
        End Get
        Set(ByVal Value As Color)
            COL = Value
        End Set
    End Property

#End Region

#Region "FORM"

    Private Sub stage_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Icon = Nothing
        Me.Location = New Point(0, 0)
        Me.Width = Me.ParentForm.ClientSize.Width - 10
        Me.Height = Me.ParentForm.ClientSize.Height - 10
    End Sub

#End Region

#Region "GRAFICA"

    Private Function EseguiDisegno(ByVal Operazione As String, ByVal X As Integer, ByVal Y As Integer, ByVal Altezza As Integer, ByVal Larghezza As Integer, ByVal Colore As Color, Optional ByRef MAP As Bitmap = Nothing) As Boolean
        'esegue i disegni
        Static B As Bitmap = New Bitmap(Pic1.Width, Pic1.Height)
        Static Grafica As Graphics = Graphics.FromImage(B)

        Select Case Operazione

            Case "esporta"

                ' esporta il file in formato grafico
                Try
                    Dim SFD As New SaveFileDialog
                    SFD.CheckPathExists() = True
                    SFD.Title = "Salva il file come .bmp"
                    SFD.CheckFileExists() = False
                    SFD.InitialDirectory = GetApplicationPath()
                    SFD.ValidateNames = True
                    SFD.Filter = " File immagine (*.bmp)|*.bmp"
                    SFD.OverwritePrompt = True

                    If SFD.ShowDialog = DialogResult.OK Then
                        B.Save(SFD.FileName, System.Drawing.Imaging.ImageFormat.Bmp)
                        Return True
                    Else
                        Return False
                    End If

                Catch ex As Exception
                    MsgBox(ex.Message, MsgBoxStyle.Information, "ERR [29]")
                    Return False
                End Try

            Case "stampa"
                ' Make a Bitmap to hold the image.
                Dim bm_gr As Graphics = Grafica.FromImage(B)
                Dim bm_hdc As IntPtr = bm_gr.GetHdc
                ' Get the form's hDC. We must do this after 
                ' creating the new Bitmap, which uses me_gr.
                Dim me_hdc As IntPtr = Grafica.GetHdc

                ' BitBlt the form's image onto the Bitmap.
                BitBlt(bm_hdc, 0, 0, Me.Pic1.Width, Me.Pic1.Height, _
                    me_hdc, 0, 0, SRCCOPY)
                Grafica.ReleaseHdc(me_hdc)
                bm_gr.ReleaseHdc(bm_hdc)
                ' Return the result.
                MAP = B

            Case "inizializza"
                Dim Myb As New SolidBrush(Colore)
                Grafica.FillRectangle(Myb, X, Y, Larghezza, Altezza)
                Pic1.Image = B

            Case "disegno"
                Dim Myb As New SolidBrush(Colore)
                Grafica.FillRectangle(Myb, X, Y, Larghezza, Altezza)
                Pic1.Image = B

            Case Else
                Return False
        End Select

    End Function

#End Region

#Region "MOUSE_MOVE"

    Private Sub Pic1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pic1.MouseMove
        ' il mouse si muove sullo stage
        If InizioDisegno = True Then
            Dim X, Y As Integer
            X = e.X
            Y = e.Y
            EseguiDisegno("disegno", X, Y, ALT, LAR, COL)
        End If
    End Sub

    Private Sub Pic1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pic1.MouseUp
        InizioDisegno = False
    End Sub

    Private Sub Pic1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pic1.MouseDown
        InizioDisegno = True
    End Sub

#End Region

#Region "PROCEDURE-FUNZIONI"

    Private Function GetApplicationPath() As String
        ' directory dove  istallato il software
        Try

            Return System.IO.Path.GetDirectoryName _
        (System.Reflection.Assembly.GetExecutingAssembly().Location())

        Catch ex As Exception
            'ERR
            Return ""
        End Try

    End Function

    Public Sub CambiaLinea(ByVal Altezza As Integer, ByVal Larghezza As Integer, ByVal Colore As Color)
        AltezzaLinea = Altezza
        LarghezzaLinea = Larghezza
        COL = Colore
    End Sub

    Public Sub CambiaForm(ByVal Altezza As Integer, ByVal Larghezza As Integer)
        ' d le dimensioni al form
        Pic1.Width = Larghezza
        Pic1.Height = Altezza
        Me.ALTform = Altezza
        Me.LARform = Larghezza
        EseguiDisegno("inizializza", 0, 0, Pic1.Height, Pic1.Width, COLSTAGE)
    End Sub

    Public Function Stampa() As Boolean
        ' effettua la stampa
        ' Copy the form's image into a bitmap.
        Dim B As Bitmap = Nothing
        EseguiDisegno("stampa", 0, 0, 0, 0, Color.Black, B)
        m_PrintBitmap = B
        ' Make a PrintDocument and print.
        m_PrintDocument = New PrintDocument
        m_PrintDocument.Print()
    End Function

    Private Sub m_PrintDocument_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles m_PrintDocument.PrintPage
        ' Draw the image centered.
        Dim x As Integer = e.MarginBounds.X + _
            (e.MarginBounds.Width - m_PrintBitmap.Width) \ 2
        Dim y As Integer = e.MarginBounds.Y + _
            (e.MarginBounds.Height - m_PrintBitmap.Height) \ 2
        e.Graphics.DrawImage(m_PrintBitmap, x, y)
        ' There's only one page.
        e.HasMorePages = False
    End Sub

    Public Sub EsportaFile()
        EseguiDisegno("esporta", 0, 0, 0, 0, Color.Black)
    End Sub

#End Region

End Class
